<template>
    <FormComponent
        classImg="rector-img"
        title="Nuevo Registro - Rector"
        :redirectTab="redirectTab"
        :formFirstTabIsValid="formEntidadIsValid"
        @save="save()"
    >
        <template #tab-1>
            <div class="row md-8 div-reg">
                <div class="col form-group">
                    <SelectDepartamentoComponent
                        v-model="entidadForm.id_departamento"
                        :ruta="ruta"
                        :error="errorsBack.id_departamento"
                        @change="getMunicipios()"
                    />
                </div>
                <div class="col form-group">
                    <SelectMunicipioComponent
                        v-model="entidadForm.id_municipio"
                        :municipios="municipios"
                        :error="errorsBack.id_municipio"
                    />
                </div>
            </div>

            <div class="row div-reg">
                <div class="col form-group">
                    <InputTextComponent
                        label="Nombre Institución Educativa"
                        v-model="entidadForm.nombre_entidad"
                        placeholder="Introduzca Nombre Institución Educativa"
                        :error="errorsBack.nombre_entidad"
                    />
                </div>
                <div class="col form-group">
                    <InputTextComponent
                        label="Dirección Institución Educativa"
                        v-model="entidadForm.direccion_entidad"
                        placeholder="Introduzca Dirección Institución Educativa"
                        :error="errorsBack.direccion_entidad"
                    />
                </div>
            </div>

            <div class="row div-reg">
                <div class="col form-group">
                    <InputTextComponent
                        label="Nit"
                        v-model="entidadForm.nit_entidad"
                        placeholder="Introduzca Nit"
                        :error="errorsBack.nit_entidad"
                    />
                </div>
                <div class="col form-group">
                    <InputTextComponent
                        label="Dane"
                        v-model="entidadForm.dane"
                        placeholder="Introduzca Dane"
                        :error="errorsBack.dane"
                    />
                </div>
            </div>

            <div class="row div-reg">
                <div class="col form-group">
                    <InputTextComponent
                        label="Correo Electrónico"
                        v-model="entidadForm.correo_entidad"
                        placeholder="Introduzca Correo"
                        :error="errorsBack.correo_entidad"
                    />
                </div>
            </div>

            <div class="row div-reg">
                <div class="col form-group">
                    <label for="text">Escudo Institución Educativa</label>
                    <input
                        type="file"
                        id="js-input-file-escudo"
                        class="form-control"  
                        placeholder="Foto" 
                        accept="image/*"
                        @change="onChangeInputFile"
                    />
                </div>
                <div class="col form-group">
                    <InputTextComponent
                        label="Teléfono Institución Educativa"
                        v-model="entidadForm.telefono_entidad"
                        placeholder="Introduzca Teléfono"
                        :error="errorsBack.telefono_entidad"
                        onlyNumbers
                        :limitCharacters="10"
                    />
                </div>
            </div>
        </template>

        <template #tab-2>
            <form>
                <div class="row div-reg">
                    <div class="col form-group">
                        <InputTextComponent
                            label="Nombre(s)"
                            v-model="userForm.nombres_usuario"
                            placeholder="Introduzca Nombre(s)"
                            :error="errorsBack.nombres_usuario"
                        />
                    </div>
                    <div class="col form-group">
                        <InputTextComponent
                            label="Apellidos"
                            v-model="userForm.apellidos_usuario"
                            placeholder="Introduzca Apellidos"
                            :error="errorsBack.apellidos_usuario"
                        />
                    </div>
                </div>

                <div class="row div-reg">
                    <div class="col form-group">
                        <InputTextComponent
                            label="Número de Identificacion"
                            v-model="userForm.cedula_usuario"
                            placeholder="Introduzca Identificacion"
                            :error="errorsBack.cedula_usuario"
                            onlyNumbers
                        />
                    </div>
                    <div class="col form-group">
                        <InputTextComponent
                            label="Telefono"
                            v-model="userForm.telefono_usuario"
                            placeholder="Introduzca Telefono"
                            :error="errorsBack.telefono_usuario"
                            onlyNumbers
                            :limitCharacters="10"
                        />
                    </div>
                </div>

                <div class="row div-reg">
                    <div class="col form-group">
                        <InputTextComponent
                            label="Correo Electronico"
                            v-model="userForm.email"
                            placeholder="Introduzca Correo Electronico"
                            :error="errorsBack.email"
                        />
                    </div>
                </div>

                <div class="row div-reg">
                    <div class="col form-group mb-4">
                        <InputTextComponent
                            label="Contraseña"
                            type="password"
                            v-model="userForm.password"
                            placeholder="Introduzca tu contraseña"
                            :error="errorsBack.password"
                            autocomplete=""
                        />
                    </div>
                    <div class="col form-group mb-4">
                        <InputTextComponent
                            label="Contraseña"
                            type="password"
                            v-model="password"
                            placeholder="Repite tu contraseña"
                            :error="errorsBack.repeatPassword"
                            autocomplete=""
                        />
                    </div>
                </div>
            </form>
        </template>
    </FormComponent>
</template>

<script>
import FormComponent               from './../../../components/formComponent.vue';
import SelectDepartamentoComponent from './../../../components/selectDepartamentoComponent.vue';
import SelectMunicipioComponent    from './../../../components/selectMunicipioComponent.vue';
import InputTextComponent          from './../../../components/inputTextComponent.vue';
import { invalidEmail }            from './../../../utils/emailChecker';
import { isEmpty }                 from './../../../utils/isEmpty';

export default {

    props: ['ruta'],

    components: {
        FormComponent,
        SelectDepartamentoComponent,
        SelectMunicipioComponent,
        InputTextComponent
    },

    data: () => {
        return {
            redirectTab: 0,
            municipios: [],
            password: "",
            entidadForm: {
                id_departamento: 0,
                id_municipio: 0,
                nit_entidad: "",
                dane: "",
                nombre_entidad: "",
                telefono_entidad: "",
                direccion_entidad: "",
                correo_entidad: "",
                escudo: null,
                id_estado: 1,
            },

            userForm : {
                cedula_usuario: "",
                nombres_usuario: "",
                apellidos_usuario: "",
                telefono_usuario: "",
                email: "",
                password: "",
                id_estado: 1
            },

            errorsBack: {
                id_departamento: "",
                id_municipio: "",
                nit_entidad: "",
                dane: "",
                nombre_entidad: "",
                telefono_entidad: "",
                direccion_entidad: "",
                correo_entidad: "",
                escudo_entidad: "",
                id_estado: "",
                cedula_usuario: "",
                nombres_usuario: "",
                apellidos_usuario: "",
                telefono_usuario: "",
                email: "",
                password: "",
                id_estado: "",
                repeatPassword: ""
            },
        }
    },

    methods: {

        async getMunicipios() {

            this.entidadForm.id_municipio = 0;

            const response = await axios.get(this.ruta + 
                `/api/municipios?filter[idDepartamento]=${this.entidadForm.id_departamento}`
            );

            this.municipios = response.data['data'];
        },

        reserErrors() {
            Object.entries(this.errorsBack)
                .forEach(([key, value]) => this.errorsBack[key] = "");
        },

        onChangeInputFile(event) {
            this.entidadForm.escudo = event.target.files[0];
        },

        async save() {
            
            this.redirectTab = 0;
            this.reserErrors();

            if (this.formUsuarioIsInvalid()) return;

            try {

                const dataPost = new FormData();

                const params = JSON.stringify({ ...this.entidadForm, ...this.userForm });
                dataPost.append('params', params);
                dataPost.append('escudo', this.entidadForm.escudo || "")

                const response = await axios.post(this.ruta + '/api/entidades', dataPost);
                
                this.$utils.showWarning(response.data['message']);
                this.$router.push({ name: 'login' });

            } catch (error) {

                const errorRequest = JSON.parse(error.request.response);

                Object.entries(errorRequest['errors'])
                    .forEach(([key, value]) => this.errorsBack[key] = value[0]);

                if (errorRequest['type'] == 'Entidad') this.redirectTab = 1;
                if (errorRequest['type'] == 'Usuario') this.redirectTab = 2;                
            }
        },

        formEntidadIsValid() {

            var errorCount = 0;
            this.reserErrors();

            if (isEmpty(this.entidadForm.id_departamento)) {
                this.errorsBack.id_departamento = "Departamento es requerido";
                errorCount++;            
            }

            if (isEmpty(this.entidadForm.id_municipio)) {
                this.errorsBack.id_municipio = "Municipio es requerido";
                errorCount++;            
            }

            if (isEmpty(this.entidadForm.nombre_entidad)) {
                this.errorsBack.nombre_entidad = "Nombre es requerido";
                errorCount++;            
            }

            if (isEmpty(this.entidadForm.direccion_entidad)) {
                this.errorsBack.direccion_entidad = "Dirección es requerido";
                errorCount++;            
            }

            if (isEmpty(this.entidadForm.nit_entidad)) {
                this.errorsBack.nit_entidad = "Nit es requerido";
                errorCount++;            
            }

            if (isEmpty(this.entidadForm.dane)) {
                this.errorsBack.dane = "Dane es requerido";
                errorCount++;            
            }

            if (isEmpty(this.entidadForm.correo_entidad)) {
                this.errorsBack.correo_entidad = "Correo es requerido";
                errorCount++;            
            }

            if (invalidEmail(this.entidadForm.correo_entidad)) {
                this.errorsBack.correo_entidad = "Correo inválido";
                errorCount++;  
            }

            if (isEmpty(this.entidadForm.telefono_entidad)) {
                this.errorsBack.telefono_entidad = "Teléfono es requerido";
                errorCount++;            
            }

            return errorCount == 0;
        },

        formUsuarioIsInvalid() {

            var errorCount = 0;
            this.reserErrors();

            if (isEmpty(this.userForm.nombres_usuario)) {
                this.errorsBack.nombres_usuario = "Nombres es requerido";
                errorCount++;            
            }

            if (isEmpty(this.userForm.apellidos_usuario)) {
                this.errorsBack.apellidos_usuario = "Apellidos es requerido";
                errorCount++;            
            }

            if (isEmpty(this.userForm.cedula_usuario)) {
                this.errorsBack.cedula_usuario = "Cédula es requerido";
                errorCount++;            
            }

            if (isEmpty(this.userForm.telefono_usuario)) {
                this.errorsBack.telefono_usuario = "Teléfono es requerido";
                errorCount++;            
            }

            if (isEmpty(this.userForm.email)) {
                this.errorsBack.email = "Correo es requerido";
                errorCount++;            
            }

            if (invalidEmail(this.userForm.email)) {
                this.errorsBack.email = "Correo inválido";
                errorCount++;     
            }

            if (isEmpty(this.userForm.password)) {
                this.errorsBack.password = "Contraseña es requerido";
                errorCount++;            
            }

            if (isEmpty(this.password)) {
                this.errorsBack.repeatPassword = "Confirmar contrseña es requerido";
                errorCount++;            
            }

            if (this.password != this.userForm.password) {
                this.errorsBack.repeatPassword = "Contraseña no coincide";
                errorCount++;            
            }

            return errorCount > 0;
        }
    }
}
</script>